using System;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using System.Collections.Specialized;

namespace GroupingData
{
	/// <summary>
	/// Summary description for GroupData.
	/// </summary>
	public class GroupData
	{
		public GroupData()
		{
			
		}

		public static DataTable GetTable(int nRows)
		{
			
			InitSomeDataChoices();

			DataTable dt = new DataTable("MyGroupTable");

			dt.Columns.Add(new DataColumn("id", typeof(int)));
			dt.Columns.Add(new DataColumn("FName"));
			dt.Columns.Add(new DataColumn("LName"));
			dt.Columns.Add(new DataColumn("Age", typeof(int)));
			dt.Columns.Add(new DataColumn("Job"));
			dt.Columns.Add(new DataColumn("Hobby"));
			dt.Columns.Add(new DataColumn("State"));
			dt.Columns.Add(new DataColumn("OK", typeof(bool)));

			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;
				dr[1] = FNames[r.Next(FNames.Count)];
				dr[2] = LNames[r.Next(LNames.Count)];
				dr[3] = r.Next(40) + 20;
				dr[4] = Jobs[r.Next(Jobs.Count)];
				dr[5] = Hobbies[r.Next(Hobbies.Count)];
				dr[6] = States[r.Next(States.Count)];
				dr[7] = (i % 3) == 0;
				dt.Rows.Add(dr);
			}

			return dt;

		}

		private static StringCollection FNames;
		private static StringCollection LNames;
		private static StringCollection Hobbies;
		private static StringCollection Jobs;
		private static StringCollection States;

		private static void InitSomeDataChoices()
		{
			FNames = new StringCollection();
			LNames = new StringCollection();
			Hobbies = new StringCollection();
			Jobs = new StringCollection();
			States = new StringCollection();

			FNames.AddRange(new string[] {"John", "Joe", "Arun", "Sarah", "Bill", "Emma", "Elizabeth", "Jane", "George", "Thomas", "Herb"});
			LNames.AddRange(new string[] {"Knightly", "Bingley", "Darcy", "Bennett", "Thompson", "Smith", "Pao", "Hurst", "Cain", "Jones"});
			Hobbies.AddRange(new string[] {"Reading", "TV", "Golf", "Baseball", "Football", "Knitting", "Coding", "Driving", "Gardening", "Games", "Puzzles"});
			Jobs.AddRange(new string[] {"Accountant", "Salesman", "Programmer", "Teacher", "Lawyer", "Welder", "Doctor", "Plumber", "Golfer", "Electrician", "HandyMan"});
			States.AddRange(new string[] {"AL", "AR", "GA", "SC", "NE", "CA", "NC", "MO", "IL", "NY", "NJ"});


		}

		public static DataTable GetTable(int nRows, int nCols)
		{
			DataTable dt = new DataTable("RandomTable");		 
			for(int i = 0; i < nCols; ++i)
			{
				dt.Columns.Add(new DataColumn(string.Format("Column{0}", i)));
			}
			Random r = new Random();
			int[] counts = new int[nCols];
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; ++j)
				{
					if(i == 0)
					{
						counts[j] = r.Next(8) + 5;
					}
					if(j == 0)
					{
						dr[j] = i.ToString();
								
					}
					else
					{
						//dr[j] = string.Format("colVal{0}", i % counts[j]);
						dr[j] = string.Format("col{1}Val{0}", r.Next(counts[j]), j);
					}
				}
				dt.Rows.Add(dr);
			}
		
			return dt;
		}
	}
}
